-----------------------------------------------------------------------------------------------
-- Author Charge in 

-- Client Lua Script for GetMembers
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------
 
require "Window"
 
-----------------------------------------------------------------------------------------------
-- GetMembers Module Definition
-----------------------------------------------------------------------------------------------
local GetMembers = {}

 
-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
-- e.g. local kiExampleVariableMax = 999
 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function GetMembers:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

	o.MemberListSave = {}
    -- initialize variables here

    return o
end

function GetMembers:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		-- "UnitOrPackageName",
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 

-----------------------------------------------------------------------------------------------
-- GetMembers OnLoad
-----------------------------------------------------------------------------------------------
function GetMembers:OnLoad()
    -- load our form file
	self.xmlDoc = XmlDoc.CreateFromFile("GetMembers.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
	
end

-----------------------------------------------------------------------------------------------
-- Save and Restore
-----------------------------------------------------------------------------------------------
function GetMembers:OnSave(eType)

	if eType ~= GameLib.CodeEnumAddonSaveLevel.General then 
		return nil
	end
	return self.MemberListSave
end


function GetMembers:OnRestore (eType, tSavedData)

	if eType ~= GameLib.CodeEnumAddonSaveLevel.General then
		return nil
	end
	
	for k,v in pairs(tSavedData) do
		
		self.MemberListSave[k] = v
		
	end

end




-----------------------------------------------------------------------------------------------
-- GetMembers OnDocLoaded
-----------------------------------------------------------------------------------------------
function GetMembers:OnDocLoaded()

	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	    self.wndMain = Apollo.LoadForm(self.xmlDoc, "GetMembersForm", nil, self)
		if self.wndMain == nil then
			Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
			return
		end
		
		--self.IsParsing = false
		--self.name = nil
		Apollo.RegisterSlashCommand("gm","OpenWindow", self)
		Apollo.RegisterSlashCommand("Gm","OpenWindow", self)
		Apollo.RegisterSlashCommand("GM","OpenWindow", self)
	    self.wndMain:Show(false, true)

		-- if the xmlDoc is no longer needed, you should set it to nil
		-- self.xmlDoc = nil
		
		-- Register handlers for events, slash commands and timer, etc.
		-- e.g. Apollo.RegisterEventHandler("KeyDown", "OnKeyDown", self)


		-- Do additional Addon initialization here
	end
	self:LoadNames()
	self:ChatParse()
end

-----------------------------------------------------------------------------------------------
-- GetMembers Functions
-----------------------------------------------------------------------------------------------
-- Define general functions here

function GetMembers:OpenWindow(strCommand,strGetName)
		
	if strGetName ~= "" then
		self:ChatAdd(strGetName)
	elseif strGetName == "" then
		self.wndMain:Show(true, true)
	end
	

end



-----------------------------------------------------------------------------------------------
-- GetMembersForm Functions
-----------------------------------------------------------------------------------------------
-- when the OK button is clicked
function GetMembers:OnOK()
	self.wndMain:Close() -- hide the window
end

-- when the Cancel button is clicked
function GetMembers:OnCancel()
	self.wndMain:Close() -- hide the window
end


--Main invite function
function GetMembers:ChatAdd(strGetName)	
	
if  strGetName ~= nil then
		ChatSystemLib.Command("/ginvite "..strGetName)
		self.wndMain:FindChild("AddedName"):SetText("Enter Name")
		--self.name = strGetName
	end
	
	--self:ChatParse()
	
end

function GetMembers:Accepted(strGetName)

	local wndMemberlist = self.wndMain:FindChild("Memberlist")	
	local wndNewMember = Apollo.LoadForm(self.xmlDoc,"Member", wndMemberlist, self)
	local Time = GameLib.GetLocalTime()
	
	wndNewMember:FindChild("MemberName"):SetText(strGetName)
	wndNewMember:FindChild("Date"):SetText(tostring(Time.nDay).."-"..tostring(Time.nMonth).."-"..tostring(Time.nYear).." "..Time.strFormattedTime)
	self.MemberListSave[strGetName] = tostring(Time.nDay).."-"..tostring(Time.nMonth).."-"..tostring(Time.nYear).." "..Time.strFormattedTime
	--wndMemberlist:ArrangeChildrenVert(0,GetMembers.Date)
	self:LoadNames()
end


function GetMembers:ChatParse()
	Apollo.RegisterEventHandler("ChatMessage", "ControlChatMessage", self)
end

function GetMembers:ControlChatMessage(tChannel , tMessage)

	local ChatChannelType = tChannel:GetType()
	if (ChatChannelType == ChatSystemLib.ChatChannel_Guild) then
	
		local Message = tMessage.arMessageSegments[1].strText
		local prename, lastname,t,keyword = Utils:Split(Message," ")

		if( t == "has") and (keyword == "joined") then
			local fullname = prename.." "..lastname
			self:Accepted(fullname)
		end
	end

end



function GetMembers:ExitEditboxName(wndHandler, wndControl)
	wndControl:GetParent():FindChild("AddedName"):SetText("Enter Name")
end


function GetMembers:Add(wndHandler, wndControl)
	
	local strGetName = wndControl:GetParent():FindChild("AddedName"):GetText()
		
	self:ChatAdd(strGetName)
end

function GetMembers:ExitEditboxName(wndHandler, wndControl)
	wndControl:GetParent():FindChild("AddedName"):SetText("Enter Name")
end




function GetMembers:Remove(wndHandler, wndControl)

	local wndMember  = wndControl:GetParent()
	self.MemberListSave[wndMember:FindChild("MemberName"):GetText()] = nil
	wndMember:Destroy()
	
	self.wndMain:FindChild("Memberlist"):ArrangeChildrenVert(0,GetMembers.Date)
	

end

function GetMembers.Date(a,b)

	local strA = a:FindChild("Date"):GetText()
	local strB = b:FindChild("Date"):GetText()
	
	local a1,a2,a3 = Utils:Split(strA, "-")
	local b1,b2,b3 = Utils:Split(strB, "-")
	b3 = Utils:Split(b3, " ")
	a3 = Utils:Split(a3, " ")
	local Na1 = tonumber(a1)
	local Na2 = tonumber(a2)
	local Na3 = tonumber(a3)
	local Nb1 = tonumber(b1)
	local Nb2 = tonumber(b2)
	local Nb3 = tonumber(b3)
	if (Na3 > Nb3) then
		return true
	end
	if Na3 < Nb3 then
		return false
	end
	if Na2 > Nb2 then
		return true 
	end
	if Na2 < Nb2 then
		return false
	end
	if Na1 >= Nb1 then
		return true 
	end
	if Na2 < Nb2 then
		return false
	end
	return false
end


function GetMembers:LoadNames()
	if self.MemberListSave.Date ~= {} then
		local wndMemberlist = self.wndMain:FindChild("Memberlist")

		wndMemberlist:DestroyChildren()
	
		for k,v in pairs(self.MemberListSave) do
		
			local wndNewMember = Apollo.LoadForm(self.xmlDoc,"Member", wndMemberlist, self)
			wndNewMember:FindChild("MemberName"):SetText(k)
			wndNewMember:FindChild("Date"):SetText(v)
		end
		self.wndMain:FindChild("Memberlist"):ArrangeChildrenVert(0,GetMembers.Date)
	end
	
	
end

function GetMembers:Promote (wndHandler, wndControl)
	
	local strGetName = wndControl:GetParent():FindChild("MemberName"):GetText()
	ChatSystemLib.Command("/gpromote "..strGetName)

	
end






-----------------------------------------------------------------------------------------------
-- GetMembers Instance

-----------------------------------------------------------------------------------------------


local GetMembersInst = GetMembers:new()
GetMembersInst:Init()


-----------------------------------------------------------------------------------------------
-- Extra Function

-----------------------------------------------------------------------------------------------
Utils = {}

-- Source: Raid Looter by Johan Lindström
-- Compatibility: Lua-5.1
function Utils:Split(str, pat)
   local t = {}  -- NOTE: use {n = 0} in Lua-5.0
   local fpat = "(.-)" .. pat
   local last_end = 1
   local s, e, cap = str:find(fpat, 1)
   while s do
      if s ~= 1 or cap ~= "" then
	 table.insert(t,cap)
      end
      last_end = e+1
      s, e, cap = str:find(fpat, last_end)
   end
   if last_end <= #str then
      cap = str:sub(last_end)
      table.insert(t, cap)
   end
   return unpack(t)
end

